<?

function tree_property_resolver($prop, $sobject) {

 global $T_PROPERTY, $ICO_FOLDER, $ICO_PROPERTY;

 global $NODE_OBJ_REFS;
 $object =& node_unserialize($sobject);
 if (is_a($object,"nodeexception")) return array();

 $rs = array();
 if (!method_exists($object, "getPropertyNames") || !method_exists($object, "getProperty")) return array();
 $props = $object->getPropertyNames();

 reset($props);
 while (list($key, $val) = each($props)) {
 if ( $key ) {
 $cobj = $object->getProperty($key);

 if (method_exists($cobj, "getIcon")) $ico = $cobj->getIcon();
 else $ico = $ICO_PROPERTY;
 if (!$ico) $ico = $ICO_PROPERTY;

 $o = array();
 $o["id"] = $prop . ($prop?"":"") . $key;
 $o["type"] = $T_PROPERTY;
 $o["name"] = $val;
 $o["icon"] = $ico;
 $o["sobject"] = addslashes(node_serialize($cobj));
 $rs[] = $o;
 }
 }
 return $rs;
}

class PropertyTreeComponent extends SelectableFormComponent {

 var $rootObject;
 var $selected=FALSE;
 var $prop;

 function PropertyTreeComponent( &$rootObject ) {
 parent::SelectableFormComponent();
 $this->rootObject =& $rootObject;
 $this->unsetProperty();
 }

 function& getRootObject()
 {
 return $this->rootObject;
 }
 
 function setProperty($prop) {
 $this->prop = $prop;
 $this->selected = true;
 }

 function unsetProperty() {
 $this->selected = false;
 $this->prop = "";
 }

 function getProperty() {
 return $this->prop;
 }

 function getObject() {
 if (!$this->selected) return new NodeException("PropertyTree: Object not yet selected.");
 node_func("resolveProperty");
 return resolveProperty( $this->prop, $this->getRootObject() );
 }

 function &getResultObject() {
 if (!$this->selected) return new NodeException("PropertyTree: Object not yet selected.");
 return new StringObject($this->prop);
 }

 function setObject(&$obj) {
 
 $this->setProperty($obj->toString());
 }

 function reset() {
 $this->unsetObject();
 }

 function getSerializeKey() {
 $rs = parent::getSerializeKey();
 $rs["rootObj"] = node_serialize($this->rootObject);
 $rs["prop"] = $this->prop;
 $rs["selected"] = $this->selected;
 return $rs;
 }

 function initFromSerializeKey( $key ) {
 parent::initFromSerializeKey( $key );
 $this->rootObject = &node_unserialize($key["rootObj"]);
 $this->selected = $key["selected"];
 if ( $this->selected ) {
 $this->setProperty($key["prop"]);
 }
 }

 function getFields()
 {
 return array_merge( parent::getFields(), array("prop"=>i18n("Selected Property")) );
 }
 
 function onLoadFinished() {
 if ($this->d_values["prop"]) {
 $this->setProperty(str_replace("",".",$this->d_values["prop"]));
 $this->selectionFinished();
 $this->d_values["prop"] = "";
 }
 }

 function getHTML( &$form, $prefix, $doCheck, $checkSeverity, $key ) {
 
 global $STAG, $DO, $T_PROPERTY;
 $T_PROPERTY_ROOT = 238383;
 
 node_include("tree");
 node_include("i18n");
 node_func("resolveProperty");
 
 $tree = new tree(array());
 $tree->openvar = $prefix."_openvar";
 $tree->treelink = "$STAG&do=$DO";
 $tree->showasform = true;
 $tree->linksubmit = $form->getFormName();
 $tree->linksubmitaction = $form->getNoncheckingJsSubmitCall();

 $root = &$this->getRootObject();
 $selfNameObj = $root->getProperty("name");

 $tree->type = array();
 $tree->type[$T_PROPERTY_ROOT]["name"] = i18n("Property");
 $tree->type[$T_PROPERTY_ROOT]["object"] = false;
 $tree->type[$T_PROPERTY_ROOT]["self_fkt"] = "\"".$selfNameObj->toString()."\"";
 $tree->type[$T_PROPERTY_ROOT]["fkt"] = "tree_property_resolver( \\\"\$nid\\\", \\\"\$sobject\\\" )";
 $tree->type[$T_PROPERTY_ROOT]["ntype"] = "type";
 $tree->type[$T_PROPERTY_ROOT]["nid"] = "id";
 $tree->type[$T_PROPERTY_ROOT]["nname"] = "name";
 $tree->type[$T_PROPERTY_ROOT]["allowlink"] = false;
 $tree->type[$T_PROPERTY_ROOT]["folderopen"] = "\$icon";
 $tree->type[$T_PROPERTY_ROOT]["folderclosed"] = "\$icon";

 $tree->type[$T_PROPERTY]["name"] = i18n("Property");
 $tree->type[$T_PROPERTY]["object"] = false;
 $tree->type[$T_PROPERTY]["fkt"] = "tree_property_resolver( \\\"\$nid\\\", \\\"\$sobject\\\" )";
 $tree->type[$T_PROPERTY]["ntype"] = "type";
 $tree->type[$T_PROPERTY]["nid"] = "id";
 $tree->type[$T_PROPERTY]["nname"] = "name";
 $tree->type[$T_PROPERTY]["allowlink"] = true;
 $tree->type[$T_PROPERTY]["link"] = "&do=$DO";
 $tree->type[$T_PROPERTY]["linkvar"] = $prefix."prop";
 $tree->type[$T_PROPERTY]["linktarget"] = "_self";
 $tree->type[$T_PROPERTY]["folderopen"] = "\$icon";
 $tree->type[$T_PROPERTY]["folderclosed"] = "\$icon";

 $rootVal = array( "sobject"=>addslashes(node_serialize($this->rootObject)), "icon"=>$root->getIcon() );

 $html = "<table><tr valign=top><td>";
 $html .= $tree->walktree("", false, 0, $T_PROPERTY_ROOT, "", "", $rootVal );
 $html .= "</td><td width=15>&nbsp;&nbsp;</td><td>";
 
 if ($this->selected) {
 $html .= "<b>".$this->prop."</b><br><br>";
 $html .= $this->_getPropDescription($this->prop);
 }
 
 $html .= "</td></tr></table>";
 
 return $this->mergeResult( parent::getHTML( $form, $prefix, $doCheck, $checkSeverity, $key ), $html );
 }

 function toString() {
 return $this->prop;
 }

 function isFinished() {
 return $this->selected;
 }

 function _getPropDescription($prop) {
 if (!$prop) return "";
 
 $props = explode(".",$prop);
 $tprop = $props[count($props) - 1];
 unset($props[count($props) - 1]);
 $mprop = implode(".",$props);
 
 $html = "";
 
 node_func("resolveproperty");
 $oprop = resolveProperty($mprop, $this->getRootObject());
 if (method_exists($oprop, "getPropertyNames")) {
 $rs = $oprop->getPropertyNames();
 $html .= $rs[$tprop];

 $rs = $oprop->getProperty($tprop);
 $html .= "<br><br>\n<i>".$rs->toString()."</i>";
 }
 
 return $html;
 }

}

?>
