<?

GUIFactory::setMainGUI( "main" );
construct_load();

include( "$NODEPATH/modules/$MODULE/include/objprop_formatters.inc.php" );

mysession_var_reg("OBJPROP");
if ($id) $OBJPROP = $id;


class NameFormatter extends ResultsetFormatter {
 function format( $row ) {
 $r = $row['readablename'];
 if(!$r) return $row['name'];
 return $r;
 }
}

class IconFormatter extends ResultsetFormatter {
 var $colname;

 function IconFormatter( $colname ) {
 $this->colname = $colname;
 }
 function format( $row ) {
 global $invalid_tags;
 return img( tag_icon( $row[$this->colname] ), 0 );
 }
}

class NodeFormatter extends ResultsetFormatter {
 function format( $row ) {
 $objprop_id = $row['objprop_id'];
 $res = '';
 if($objprop_id) {
 $sql = "SELECT folder.name FROM objprop_node INNER JOIN node ON objprop_node.node_id = node.id INNER JOIN folder ON node.folder_id = folder.id WHERE objprop_node.objprop_id = '".sqlf_escaped($objprop_id)."'";
 $rs = query( $sql );
 $i = 0;
 foreach( $rs['arr'] as $node ) {
 if( $res ) $res .= ', ';
 if( $i++ > 2 ) { $res .= '...'; break; }
 $res .= $node['name'];
 }
 }
 if( $res ) return $res;
 return i18n( 'All' );
 }
}

class ConstructFormatter extends ResultsetFormatter {
 function format( $row ) {
 global $CONSTRUCTS;
 return $CONSTRUCTS[$row['construct_id']];
 }
}

function deleteObjectProperty( $id ) {
 global $LOAD_MODULE;
 cmd_objprop_del(array($id => ''));
 if ($LOAD_MODULE["content"]) CNDirt::dirtAll();
}

class PermissionFilter extends SQLDatasourceFilter {
 function PermissionFilter() {
 }
 function checkRow( $row ) {
 global $FEATURE, $USER_ID, $T_OBJPROPELEMENT;
 if ( $FEATURE['objtag_perm'] && !perm($USER_ID, $T_OBJPROPELEMENT, $row['id'], 0) ) return false;
 return true;
 }
}


$select = "objtag.id, objtag.name, objtag.name AS orig_name, objtag.construct_id, objtag.inheritable, construct.icon, objtag.required, objtag.inpage, objprop.name_id, dicname.value AS readablename,IF(dicname.value IS NULL OR dicname.value = '', objtag.name, dicname.value) AS sortname,objprop.description_id, dicdescr.value AS description,objprop.id AS objprop_id, objprop_category.name_id AS category_name_id, diccategory.value AS category_name, objprop_category.sortorder IS NULL AS sortorder_isnull, objprop_category.sortorder";
$from = "objtag
 INNER JOIN construct ON objtag.construct_id = construct.id
 LEFT JOIN objprop ON objprop.objtag_id = objtag.id
 LEFT JOIN objprop_category ON objprop.category_id = objprop_category.id
 LEFT JOIN dicuser AS diccategory ON diccategory.output_id = objprop_category.name_id AND diccategory.language_id = ".sqlf_tl_num($LANGUAGE)."
 LEFT JOIN objprop_node ON objprop_node.objprop_id = objprop.id
 LEFT JOIN dicuser AS dicname ON dicname.output_id = objprop.name_id AND dicname.language_id = ".sqlf_tl_num($LANGUAGE)."
 LEFT JOIN dicuser AS dicdescr ON dicdescr.output_id = objprop.description_id AND dicdescr.language_id = ".sqlf_tl_num($LANGUAGE)."
 LEFT JOIN node ON objprop_node.node_id = node.id
 LEFT JOIN folder ON node.folder_id = folder.id ";
$where = "objtag.obj_type = ".sqlf_tl_num($OBJPROP)." AND objtag.obj_id = 0";
$groupby = 'objtag.id';
$orderby = 'sortorder_isnull ASC, objprop_category.sortorder';

$ds = new SQLDatasource( "objprop_listprop", $select, $from, $where, $groupby, $orderby );
$ds->setDBHandle( $DB );

$ds->setDefaultSort( 'category_name', 'ASC' );

$filter = new PermissionFilter();
$ds->setSQLDatasourceFilter( $filter );

$ds->addColumn( 'icon', '', 'false', false );
$ds->addFormatter( "icon", new IconFormatter( 'icon' ) );
$ds->addColumn( 'lnkname', i18n( 'Name' ), false, false, 'sortname' );
$ds->makeLink( 'lnkname', 'name', "do=453", 'list', 'id','id' );
$ds->addFormatter( 'name', new NameFormatter( ) );
$ds->addColumn( 'orig_name', i18n( 'Keyword' ), true, false, 'orig_name' );
$ds->addColumn( 'construct_id', i18n( 'Construct' ), true, false );
$ds->addFormatter( 'construct_id', new ConstructFormatter() );
$ds->addColumn( 'nodelimit', i18n( 'Nodes' ), false, false );
$ds->addFormatter( 'nodelimit', new NodeFormatter() );
$ds->addColumn( 'category_name', i18n( 'Category' ), false, false, 'sortorder_isnull, sortorder' );
$ds->addFormatter( 'category_name', new CategoryNameFormatter() );
$ds->addColumn( 'required', i18n( 'required property' ), true, true, 'required' );
$ds->addFormatter( 'required', new BooleanFormatter( 'required' ) );
$ds->addColumn( 'inheritable', i18n( 'Inheritable' ), true, true, 'inheritable' );
$ds->addFormatter( 'inheritable', new BooleanFormatter( 'inheritable' ) );

 
 

$ds->addSearchableColumn( 'objtag.name' );
$ds->addSearchableColumn( 'dicname.value' );
$ds->addSearchableColumn( 'folder.name' );
$ds->addSearchableColumn( 'node.pub_dir' );
node_class('commandaction');
if ( !$FEATURE['deactivate_objpropedit'] &&
 (!$FEATURE['objtag_perm'] || ($FEATURE['objtag_perm'] && perm($USER_ID,$T_OBJPROP,$OBJPROP,2)))) {
 $ds->addAction( new CommandAction( $ICO_DELETE, 'delete', i18n( 'Delete' ), 'deleteObjectProperty' ) );
}

$ds->setAss( '<B>'.i18n('Name').'</B>: $orig_name<BR/>".($readablename ? "<B>'.i18n('Descriptive Name').'</B>: $readablename" : "" )."'.
 '<BR/><B>'.i18n('Description').'</B>:<BR/>$description' );

$list = new ItemList3("objprop_listprop", $ds );
$list->setMaxListItems(50);
$list->setShowInfo( true );
$list->setGroupableColumns( array( 'category_name' ) );



load_menu(452,$T_OBJPROP,$OBJPROP);


?>