<?
class ContainedObjectAssFormatter {
 function format ($row ) {
 $assistent = "ID: " . $row["obj_id"] . "<br/>";
 if ($row["globalprefix"] && $row["globalid"]) {
 $assistent .= i18n("Global ID").": " . $row["globalprefix"] . "." . $row["globalid"] . "<br/>";
 }
 switch ($row["obj_type"]) {
 case T_PAGE:
 case T_IMAGE:
 case CT_FILE:
 case T_FOLDER:
 
 if ($row["folderpath"]) {
 $assistent .= i18n("Folder").":<br/>" . $row["folderpath"] . "<br/>";
 }
 break;
 }
 return $assistent;
 }
}

function &createContainedObjectList($allowedit = false, $isdeletedialog = false, $resolveprefix = NULL, $onlyselected = true, $isimport = false, $buildid = 0) {
 global $ICO_CONSTRUCT, $ICO_PAGE, $ICO_DELETE, $BUNDLE_ID;

 node_class( 'extendablecomponent' );
 node_class( 'detailcomponent' );
 node_class( 'listcomponent' );
 node_class( 'itemlistcomponent' );
 node_class( 'listcomponent' );

 node_class("pageselector");
 node_class("allselector");
 node_class("objectselectionminibrowser");
 node_class("formcomponent");

 



 $object_infos = array();

 if (!$isimport) {
 
 $ds = new ArrayDatasource( $object_infos, array( 'icon' => '', 'name' => i18n( 'Name' ) ) );
 } elseif ($isdeletedialog) {
 
 $ds = new ArrayDatasource( $object_infos, array( 'icon' => '', 'name' => i18n( 'Name' ), 'action' => i18n( 'Delete?' ) ) );
 } else {
 
 $ds = new ArrayDatasource( $object_infos, array( 'icon' => '', 'name' => i18n( 'Name' ), 'action' => i18n( 'Action' ) ) );
 }
 $ds->addAssFormatter(new ContainedObjectAssFormatter());

 if( $allowedit ) {
 $ds->addAction(new CommandAction($ICO_DELETE, "del", i18n("Delete"), "remove_contained_object"));
 } else if( $isdeletedialog ) {
 $ds->addAction(new CommandAction($ICO_DELETE, 'del', i18n("Mark for Deletion"), 'mark_delete'));
 }

 $itemlist = new ItemList3("pageinfo2".($onlyselected?'selected':'contained'), $ds );
 $itemlist->setGroupableColumns( array( 'type' ) );
 $itemlist->setNextSortWay( 'type' );
 $list = new ItemListComponent( NULL, $itemlist );
 $list->setWidth( "200px" );

 
 $components = new ListComponent();

 $minibrowser = new ObjectSelectionMinibrowser(new AllSelector(), new EventListenerFormComponent($resolveprefix . '.list'), false);
 $minibrowser->setOpen(true);
 
 
 if(!$allowedit) {
 $minibrowser->setVisible(false);
 }
 $components->setComponent("tree", &$minibrowser);
 add_all_contained_objects(&$ds, $onlyselected, $isimport, $isdeletedialog, $buildid);

 $components->setComponent("list", $list);


 return $components;
 
}

function remove_contained_object($id, $val, &$ds) {
 $ds->removeItem( $id );
}

function mark_delete($id, $val, &$ds) {
 $objects = &$ds->getItems();
 $item = &$objects[$id];
 $ds->replaceItem($id, array( "id" => $id, "name" => $item["name"], "type" => $item["type"], "icon" => $item["icon"], "action" => i18n("delete"), "obj_id" => $item["obj_id"], "obj_type" => $item["obj_type"]));
}

function add_contained_object(&$ds, &$nodeobject, $isimport = false, $isdeletedialog = false, $containedObject = null) {
 global $T_TYPE;
 
 $ttype = $nodeobject->getTType();
 $id = $nodeobject->getID();
 $cid = $ttype . '.' . $id;

 $globalprefix = $containedObject ? $containedObject->getFieldValue("globalprefix") : null;
 $globalid = $containedObject ? $containedObject->getFieldValue("globalid") : null;
 if (!$isimport) {
 
 $ds->setItem( $cid, array( 'id' => $cid, 'name' => $nodeobject->getViewLink(), 'type' => $T_TYPE[$ttype]['name'], 'icon' => img($nodeobject->getIcon()), 'obj_id' => $id, 'obj_type' => $ttype, 'folderpath' => $nodeobject->getFieldValue('folderpath'), 'globalprefix' => $globalprefix, 'globalid' => $globalid ) );
 } else {
 if ($isdeletedialog) {
 $action = "";
 } else {
 $action = i18n($nodeobject->getFieldValue('action'));
 }
 $ds->setItem( $cid, array( 'id' => $cid, 'name' => $nodeobject->getDisplayName(), 'type' => $T_TYPE[$ttype]['name'], 'icon' => img($nodeobject->getIcon()), 'action' => $action, 'obj_id' => $id, 'obj_type' => $ttype, 'folderpath' => $nodeobject->getFieldValue('folderpath'), 'globalprefix' => $globalprefix, 'globalid' => $globalid ) );
 }
}

function add_deleted_object(&$ds, &$object) {
 $ds->setItem(0, array( 'id' => 0, 'name' => $object["count"] . "x " . $object["name"], 'type' => $object["name"], 'icon' => img($object["icon"]), 'action' => i18n("deleted") ) ); 
}

function add_all_contained_objects(&$ds, $onlyselected, $isimport = false, $isdeletedialog = false, $buildid = 0) {
 global $BUNDLE_ID;

 $bundle =& NodeFactory::getStaticInstanceOf( T_BUNDLE, $BUNDLE_ID );
 if (!$isimport) {
 $bundlebuild = &NodeFactory::getStaticInstanceOf( T_BUNDLE_BUILD, $buildid );
 $objs = &$bundlebuild->getContainedObjects($onlyselected, true);

 
 $cont_pages = array();
 $cont_folders = array();
 $cont_files = array();
 $cont_images = array();

 foreach( $objs as $containedObject ) {
 $obj = &$containedObject->getActualObject();

 switch($obj->getTType()) {
 case T_PAGE:
 $cont_pages[] = $obj->getID();
 break;
 case CT_FILE:
 $cont_files[] = $obj->getID();
 break;
 case T_IMAGE:
 $cont_images[] = $obj->getID();
 break;
 case T_FOLDER:
 $cont_folders[] = $obj->getID();
 break;
 }
 }

 $cont_pages = get_folder_structure(T_PAGE, $cont_pages);
 $cont_folders = get_folder_structure(T_FOLDER, $cont_folders);
 $cont_files = get_folder_structure(CT_FILE, $cont_files);
 $cont_images = get_folder_structure(T_IMAGE, $cont_images);
 
 foreach( $objs as $containedObject ) {
 $obj = &$containedObject->getActualObject();

 switch($obj->getTType()) {
 case T_PAGE:
 $obj->setFieldValue("folderpath", $cont_pages[$obj->getID()]);
 break;
 case CT_FILE:
 $obj->setFieldValue("folderpath", $cont_files[$obj->getID()]);
 break;
 case T_IMAGE:
 $obj->setFieldValue("folderpath", $cont_images[$obj->getID()]);
 break;
 case T_FOLDER:
 $obj->setFieldValue("folderpath", $cont_folders[$obj->getID()]);
 break;
 }
 add_contained_object( &$ds, &$obj, false, false, &$containedObject);
 }

 } else {
 if ($buildid != 0) {
 $bundlebuild = &NodeFactory::getStaticInstanceOf( T_BUNDLE_BUILD, $buildid );
 } else {
 $bundlebuild = &$bundle->getInstalledBundleBuild();
 }
 if (!$bundlebuild) {
 
 return;
 }
 $bundleimport = &$bundlebuild->getLatestBundleImport();
 $objs = &$bundleimport->getContainedObjects($isdeletedialog);

 
 $cont_pages = array();
 $cont_folders = array();
 $cont_files = array();
 $cont_images = array();
 
 foreach ($objs as $obj) {
 switch($obj->getTType()) {
 case T_PAGE:
 $cont_pages[] = $obj->getID();
 break;
 case CT_FILE:
 $cont_files[] = $obj->getID();
 break;
 case T_IMAGE:
 $cont_images[] = $obj->getID();
 break;
 case T_FOLDER:
 $cont_folders[] = $obj->getID();
 break;
 }
 }
 $cont_pages = get_folder_structure(T_PAGE, $cont_pages);
 $cont_folders = get_folder_structure(T_FOLDER, $cont_folders);
 $cont_files = get_folder_structure(CT_FILE, $cont_files);
 $cont_images = get_folder_structure(T_IMAGE, $cont_images);
 
 foreach( $objs as $obj ) {
 switch($obj->getTType()) {
 case T_PAGE:
 $obj->setFieldValue("folderpath", $cont_pages[$obj->getID()]);
 break;
 case CT_FILE:
 $obj->setFieldValue("folderpath", $cont_files[$obj->getID()]);
 break;
 case T_IMAGE:
 $obj->setFieldValue("folderpath", $cont_images[$obj->getID()]);
 break;
 case T_FOLDER:
 $obj->setFieldValue("folderpath", $cont_folders[$obj->getID()]);
 break;
 }
 add_contained_object( &$ds, &$obj, true, $isdeletedialog, &$obj );
 }
 if (!$isdeletedialog) {
 $deletedObjs = &$bundleimport->getDeletedObjects();
 foreach( $deletedObjs as $obj ) {
 add_deleted_object( &$ds, &$obj );
 }
 }
 }

 sort_contained_objects( &$ds );
}

function contained_objects_compare( $a, $b ) {
 global $T_TYPE;
 list( $atype, $aid ) = explode('.', $a);
 list( $btype, $bid ) = explode('.', $b);
 return strcasecmp( $T_TYPE[$atype]['name'], $T_TYPE[$btype]['name'] );
}

function sort_contained_objects(&$ds) {
 $arr = &$ds->getItems();
 uksort( &$arr, "contained_objects_compare" );
 $ds->setItems( $arr );
}







class EventListenerFormComponent extends CollectionComponent {
 var $form;

 function EventListenerFormComponent(  $itemlistkey ) {
 parent::CollectionComponent();
 $this->setFieldValue( 'itemlistkey', $itemlistkey );
 }
 function onLoadFinished( &$form ) {
 $this->form = &$form;
 }
 function setObject(&$nodeobject) {
 
 
 $itemlistkey = $this->getFieldValue( 'itemlistkey' );
 $form = $this->form;
 $itemlist = &$form->resolveComponent( $itemlistkey );

 $list = &$itemlist->getList();
 $ds = &$list->getDatasource();
 return $this->addObject(&$ds, &$nodeobject);
 }
 function addObject(&$ds, &$nodeobject) {
 add_contained_object(&$ds, &$nodeobject);
 sort_contained_objects( &$ds );

 return 'noclose';
 }
}



?>
