<?php































require_once(INCLUDE_PATH."/common.php");

class DB_ifx extends DB_common
{
 var $connection;
 var $affected = 0;
 var $dsn = array();
 var $fetchmode = DB_FETCHMODE_ORDERED; 

 function DB_ifx()
 {
 $this->phptype = 'ifx';
 $this->dbsyntax = 'ifx';
 $this->features = array(
 'prepare' => false,
 'pconnect' => true,
 'transactions' => false,
 'limit' => 'emulate'
 );
 $this->errorcode_map = array(
 '-201' => DB_ERROR_SYNTAX,
 '-206' => DB_ERROR_NOSUCHTABLE,
 '-217' => DB_ERROR_NOSUCHFIELD,
 '-329' => DB_ERROR_NODBSELECTED,
 '-1204' => DB_ERROR_INVALID_DATE,
 '-1205' => DB_ERROR_INVALID_DATE,
 '-1206' => DB_ERROR_INVALID_DATE,
 '-1209' => DB_ERROR_INVALID_DATE,
 '-1210' => DB_ERROR_INVALID_DATE,
 '-1212' => DB_ERROR_INVALID_DATE
 );
 }

 








 function connect(&$dsninfo, $persistent = false)
 {
 if (!DB::assertExtension('informix') || !DB::assertExtension('Informix')) {
 return $this->raiseError(DB_ERROR_EXTENSION_NOT_FOUND);
 }
 $this->dsn = $dsninfo;
 $dbhost = $dsninfo['hostspec'] ? '@' . $dsninfo['hostspec'] : '';
 $dbname = $dsninfo['database'] ? $dsninfo['database'] . $dbhost : '';
 $user = $dsninfo['username'] ? $dsninfo['username'] : '';
 $pw = $dsninfo['password'] ? $dsninfo['password'] : '';

 $connect_function = $persistent ? 'ifx_pconnect' : 'ifx_connect';

 $this->connection = @$connect_function($dbname, $user, $pw);
 if (!is_resource($this->connection)) {
 return $this->ifxraiseError(DB_ERROR_CONNECT_FAILED);
 }
 return DB_OK;
 }

 




 function disconnect()
 {
 $ret = @ifx_close($this->connection);
 $this->connection = null;
 return $ret;
 }

 









 function simpleQuery($query)
 {
 $this->last_query = $query;
 if (preg_match('/(SELECT)/i', $query)) { 
 
 
 $result = @ifx_query($query, $this->connection, IFX_SCROLL);
 } else {
 $result = @ifx_query($query, $this->connection);
 }
 if (!$result) {
 return $this->ifxraiseError();
 }
 $this->affected = ifx_affected_rows ($result);
 
 
 if (preg_match('/(SELECT)/i', $query)) {
 return $result;
 }
 return DB_OK;
 }

 

 








 function nextResult($result)
 {
 return false;
 }

 

 





 function affectedRows()
 {
 return $this->affected;
 }

 







 function fetchRow($result, $fetchmode = DB_FETCHMODE_DEFAULT, $rownum=null)
 {
 if ($fetchmode == DB_FETCHMODE_DEFAULT) {
 $fetchmode = $this->fetchmode;
 }
 $res = $this->fetchInto ($result, $arr, $fetchmode, $rownum);
 if ($res !== DB_OK) {
 return $res;
 }
 return $arr;
 }

 










 function fetchInto($result, &$row, $fetchmode, $rownum=null)
 {
 if (($rownum !== null) && ($rownum < 0)) {
 return null;
 }
 
 if (!$row = @ifx_fetch_row($result, $rownum)) {
 return null;
 }
 if ($fetchmode !== DB_FETCHMODE_ASSOC) {
 $i=0;
 $order = array();
 foreach ($row as $key => $val) {
 $order[$i++] = $val;
 }
 $row = $order;
 }
 return DB_OK;
 }

 function numRows($result)
 {
 return $this->raiseError(DB_ERROR_NOT_CAPABLE);
 }

 






 function numCols($result)
 {
 if (!$cols = @ifx_num_fields($result)) {
 return $this->ifxraiseError();
 }
 return $cols;
 }

 






 function freeResult($result)
 {
 if (is_resource($result)) {
 if (!@ifx_free_result($result)) {
 return $this->ifxraiseError();
 }
 return true;
 }
 if (!isset($this->prepare_tokens[(int)$result])) {
 return false;
 }
 unset($this->prepare_tokens[(int)$result]);
 unset($this->prepare_types[(int)$result]);
 return true;
 }

 function ifxraiseError($errno = null)
 {
 if ($errno === null) {
 $errno = $this->errorCode(ifx_error());
 }

 return $this->raiseError($errno, null, null, null,
 $this->errorNative());
 }

 








 function errorCode($nativecode)
 {
 if (ereg('SQLCODE=(.*)]', $nativecode, $match)) {
 $code = $match[1];
 if (isset($this->errorcode_map[$code])) {
 return $this->errorcode_map[$code];
 }
 }
 return DB_ERROR;
 }

 





 function errorNative()
 {
 return ifx_error() . ' ' . ifx_errormsg();
 }

 

 




 function getSpecialQuery($type)
 {
 switch ($type) {
 case 'tables':
 default:
 return null;
 }
 return $sql;
 }

 
}

?>
